﻿'Programed by NAS6


Public Class MyRandom
    Private rnd As New Random
    Private xors As Integer = 123456789
    Private y As Integer = 362436069
    Private z As Integer = 521288629
    Private w As Integer = 88675123

    Public Sub New()
        xorsSRand()
    End Sub

    Public Sub xorsSRand()
        Dim i As Integer
        For i = 0 To rnd.Next()
            xorsRand()
        Next
    End Sub

    Public Function nrmRand() As Integer
        Return rnd.Next()
    End Function

    Public Function NRMRandom(ByVal nmin As Integer, ByVal nmax As Integer) As Integer
        Dim a As Double = CType(nrmRand() Mod Integer.MaxValue, Double) / CType(Integer.MaxValue, Double)
        If nmax < nmin Then
            Dim tmp As Integer = nmax
            nmax = nmin
            nmin = tmp
        End If
        Dim c As Integer = CType(a * ((CType(nmax, Double) - CType(nmin, Double)) + 1.0), Integer)
        Return c
    End Function

    Public Function DoubleNRMRandom() As Double
        Dim a As Double = CType(nrmRand() Mod Integer.MaxValue, Double) / CType(Integer.MaxValue, Double)
        Dim b As Double = CType(nrmRand() Mod Integer.MaxValue, Double) / (CType(Integer.MaxValue, Double) * CType(Integer.MaxValue, Double))
        Return a + b
    End Function


    Public Function xorsRand() As Integer
        Dim t As Integer
        t = (xors Xor (xors << 11))
        xors = y
        y = z
        z = w
        w = (w Xor (w >> 19)) Xor (t Xor (t >> 8))
        Return w
    End Function

    Public Function XORSRandom(ByVal nmin As Integer, ByVal nmax As Integer) As Integer
        Dim a As Double = CType(xorsRand() Mod Integer.MaxValue, Double) / CType(Integer.MaxValue, Double)
        If nmax < nmin Then
            Dim tmp As Integer = nmax
            nmax = nmin
            nmin = tmp
        End If
        Dim c As Integer = CType(a * ((CType(nmax, Double) - CType(nmin, Double)) + 1.0), Integer)
        Return c
    End Function

    Public Function DoubleXORSRandom() As Double
        Dim a As Double = CType(xorsRand() Mod Integer.MaxValue, Double) / CType(Integer.MaxValue, Double)
        Dim b As Double = CType(xorsRand() Mod Integer.MaxValue, Double) / (CType(Integer.MaxValue, Double) * CType(Integer.MaxValue, Double))
        Return a + b
    End Function
End Class
